/*global define*/
define([
    'testsuite/qunit',
    'testsuite/qunit-fixture!de_epages/mediagallery/ui/memoryusage-test.html',
    'jquery',
    'de_epages/mediagallery/ui/memoryusage',
    '$ready!'
], function (QUnit, fixture, $, de_epages) {
    'use strict';

    QUnit.module("de_epages/mediagallery/ui/memoryusage", {
        setup: fixture.init,
        teardown: fixture.destroy
    });

    QUnit.asyncTest("de_epages/mediagallery/ui/memoryusage", function () {

        // create widgets
        var usage = de_epages("#memoryusage").mediagalleryUiMemoryusage();

        QUnit.equal(
            usage.data('uiMediagalleryUiMemoryusage') instanceof $.Widget,
            true,
            "Memory usage widget is created and instance of jQuery.Widget"
        );

        $.each(['_create', 'destroy', 'updateUsage'], function (i, fn) {

            QUnit.equal(
                $.isFunction($.ui.mediagalleryUiMemoryusage.prototype[fn]),
                true,
                '$.isFunction(' + fn + '):'
            );

        });

        QUnit.equal(
            $(".ep-uiMemoryUsage-statusBar").find("span").hasClass("PercentageNormal"),
            true,
            "Normal memory utilisation after initialisation"
        );

        // update memory usage
        usage.mediagalleryUiMemoryusage("updateUsage", 80000);

        QUnit.equal(
            $(".ep-uiMemoryUsage-statusBar").find("span").hasClass("PercentageMiddle"),
            true,
            "Middle memory utilisation after update to a usage of 80 MB"
        );

        // update memory usage
        usage.mediagalleryUiMemoryusage("updateUsage", 95000);

        QUnit.equal(
            $(".ep-uiMemoryUsage-statusBar").find("span").hasClass("PercentageCritical"),
            true,
            "Critical memory utilisation after update to a usage of 95 MB"
        );

        // destroy widget
        usage.mediagalleryUiMemoryusage("destroy");

        QUnit.equal(
            usage.hasClass("ep-uiMemoryUsage"),
            false,
            "Class ep-uiMemoryUsage was removed"
        );

        QUnit.equal(
            usage.data("mediagalleryUiMemoryusage"),
            undefined,
            "Memory usage widget was successfully destroyed"
        );

        QUnit.start();

    });
});
