/*jslint nomen: true*/
var require = {},
    epages = {
        vars: {
            StyleUserDefinedColors: "#f00|#0f0|#0ff|#f0c"
        }
    };

(function (require) {
    'use strict';

    function config(module, conf) {
        config._(config.c[module] || (config.c[module] = {}), conf);
    }

    config.c = require.config = (require.config || {});

    config._ = function (target, copy) {
        var prop;

        for (prop in copy) {
            if (copy.hasOwnProperty(prop)) {
                if (copy[prop] instanceof Array) {
                    target[prop] = (target[prop] instanceof Array ? target[prop] : []).concat(copy[prop]);
                } else if (copy[prop] instanceof Object) {
                    config._(target[prop] || (target[prop] = {}), copy[prop]);
                } else {
                    target[prop] = copy[prop];
                }
            }
        }
    };

    // set feature flags and some other configuration stuff
    config("ep", {
        features: {
            Gadget: true,
            Placeholder: true,
            Blog: true,
            Ebay: true
        },
        iconsRoot: "myIconRoot",
        userDefinedColors: ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""]
    });

    // include plugins
    config("ckeditor/config", {
        plugins: {
            // Mediagallery cartridge
            MediaGallery: {
                position: 10,
                name: "epimage",
                group: "media"
            },

            // ExternalContent cartridge
            Gadget: {
                position: 20,
                name: "epgadget",
                group: "media"
            },

            // ExternalContent cartridge
            Placeholder: {
                position: 40,
                name: "epplaceholder"
            },

            // Forum cartridge
            Blog: {
                position: 10,
                name: "eppagebreak",
                group: "forum"
            },

            // Shop cartridge
            Link: {
                position: 10,
                name: "eplink",
                group: "various"
            },

            // Ebay cartridge
            Ebay: {
                position: 10,
                name: "epebay"
            }
        },
        contentsCss: []
    });

}(require));