/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'ep/ajax'
], function (QUnit, $, ep) {
    'use strict';

    QUnit.module("ep/ajax");

    QUnit.test("ep/ajax", function () {

        var results = {},
            jqXHR;

        $.each([0, 1, 2], function (i, name) {
            jqXHR = ep.ajax({
                url: '../ep/ajax-test-' + i + '.json',
                type: 'get',
                async: false,
                dataType: 'json',
                success: function (data) {
                    results[i] = ['success', data];
                },
                error: function (xhr, status, error) {
                    results[i] = ['error', error];
                }
            });
        });

        QUnit.deepEqual(
            results[0],
            ['error', 'Not Found'],
            "Error! JSON file should not be found."
        );

        QUnit.deepEqual(
            results[1],
            [
                'success',
                {
                    "Delete": "Löschen",
                    "New": "Neu"
                }
            ],
            "Success!"
        );

        QUnit.deepEqual(
            results[2],
            [
                'error',
                {"msg": "customError"}
            ],
            "Error! Custom Error should be thrown."
        );
    });
});